/*************************************************************************
 *
 *
 *    (c) Copyright Olimex 2009
 *
 *    File name   : extcon_test.h
 *    Description : External connectors test
 *
 *    History :
 *    1. Date        : 16, November 2009
 *       Author      : Aleksandar Mitev
 *       Description : Create
 *
 **************************************************************************/

#include "includes.h"
#include "BattConTest.h"

static void BattWriteRegs(void)
{
	for(int i = 0; i < BKP_NUM_REGS; i++) {
		BKP_WriteBackupRegister((i * (BKP_DR2 - BKP_DR1)) + BKP_DR1, i);
	}
}

static int BattCheckRegs(void)
{
	for(int i = 0; i < BKP_NUM_REGS; i++) {
		if(BKP_ReadBackupRegister((i * (BKP_DR2 - BKP_DR1)) + BKP_DR1) != i)
			return -1;
	}
	
	return 0;
}

void BattConTestIni(void)
{
	/* Enable PWR and BKP clocks */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);
	
	/* Allow access to BKP Domain */
	PWR_BackupAccessCmd(ENABLE);
}

int BattConTest(void)
{
	printf("\n\n\nTest of Battery Connector");
	if( BattCheckRegs() ) {
		BattWriteRegs();
		printf("\nERROR running test!!!");
		printf("\nFaulty connector or running for the first time!!");
		printf("\nFaulty connector or running for the first time!!");
		printf("\nFaulty connector or running for the first time!!");
		return -1;
	}

	printf("\nSUCCESS!!! Test completed.");
	return 0;
}














